﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FakeAsync
{
    public interface IAsync
    {
        void ExecuteStep(Action cont);
    }

    public abstract class Async<T> : IAsync
    {
        protected T result;
        protected bool completed = false;

        public T Result
        {
            get
            {
                if (!completed) throw new Exception("Operation not completed, did you forgot 'yield return'?");
                return result;
            }
        }

        abstract public void ExecuteStep(Action cont);
    }

    public class AsyncPrimitive<T> : Async<T>
    {
        Action<Action<T>> func;

        public AsyncPrimitive(Func<AsyncCallback, object, IAsyncResult> begin, Func<IAsyncResult, T> end)
        {
            this.Begin = begin;
            this.End = end;

            this.func = this.ActionActionT;
        }

        Func<IAsyncResult, T> End { get; set; }
        Func<AsyncCallback, object, IAsyncResult> Begin { get; set; }
        Action<T> RunInCallback { get; set; }
        Action ActionOuter {get;set;}

        private void Callback(IAsyncResult ar)
        {
            this.RunInCallback(this.End(ar));
        }

        private void ActionActionT(Action<T> cont)
        {
            this.RunInCallback = cont;
            this.Begin(this.Callback, null);
        }

        private void ActionT(T res)
        {
            this.result = res;
            this.completed = true;
            this.ActionOuter();
        }

        public override void ExecuteStep(Action cont)
        {
            this.ActionOuter = cont;
            this.func(this.ActionT);
        }
    }


    //public class AsyncPrimitive<T> : Async<T>
    //{
    //    Action<Action<T>> func;

    //    public AsyncPrimitive(Func<AsyncCallback, object, IAsyncResult> begin, Func<IAsyncResult, T> end)
    //    {
    //        this.func = (cont) => begin(delegate(IAsyncResult res) { cont(end(res)); }, null);
    //    }

    //    public override void ExecuteStep(Action cont)
    //    {
    //        func((res) =>
    //        {
    //            result = res;
    //            completed = true;
    //            cont();
    //        });
    //    }
    //}
}
